﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Syncfusion.Windows.Shared;
using Syncfusion.Windows.Chart;

namespace SyncFusionExample
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : ChromelessWindow
    {
        public ChartSeriesAnnotation cs;

        public Window1()
        {
            InitializeComponent();
            //Creating datapoints collection.
//SkinStorage.SetVisualStyle(ChartDemo, "Office2007Blue");
        }

        private void MouseLineEnter(object sender, Syncfusion.Windows.Chart.ChartMouseEventArgs e)
        {
            ChartSeries ser = sender as ChartSeries;
            ser.StrokeThickness = 5;

            // alternative code 2 do same thing
/*            for (int i = 0; i < ChartDemo.Areas[0].Series.Count; ++i)
            {
                if (!ChartDemo.Areas[0].Series[i].Highlighted)
                {
                    ChartDemo.Areas[0].Series[i].StrokeThickness = 1;
                }
            }*/

            Point pt1 = e.MouseEventArgs.GetPosition(ChartDemo.Areas[0]);
            foreach (ChartSeries series1 in this.ChartDemo.Areas[0].Series)
            {
                if (series1.Annotations != null)
                    series1.Annotations.Items.Clear();
            }

            cs = new ChartSeriesAnnotation();
            cs.Template = this.Resources["AnnotationTemplate"] as DataTemplate;
            cs.X = ChartDemo.Areas[0].PointToValue(ChartDemo.Areas[0].PrimaryAxis, pt1);
            cs.Y = ChartDemo.Areas[0].PointToValue(ChartDemo.Areas[0].SecondaryAxis, pt1);
            double x = Math.Round(ChartDemo.Areas[0].PointToValue(ChartDemo.Areas[0].PrimaryAxis, pt1));
            double y = Math.Round(ChartDemo.Areas[0].PointToValue(ChartDemo.Areas[0].SecondaryAxis, pt1));
            cs.Description = x.ToString() + "," + y.ToString();
            AnnotationsCollection an = new AnnotationsCollection();
            an.Items.Add(cs);
            ChartDemo.Areas[0].Series[1].Annotations = an;

            ToolTip tooltip = new ToolTip();
            tooltip.IsOpen = true;
            tooltip.Content = cs.Description;
/*            string str1 = e.Segment.CorrespondingPoints[0].DataPoint.X.ToString();
            string str = e.Segment.CorrespondingPoints[0].DataPoint.Y.ToString();

            tooltip.Content = str1 + "," + str;*/
            ser.ToolTip = tooltip;
/*
Add Tooltip w/ the current point
            ToolTip tooltip = new ToolTip();
            tooltip.IsOpen = true;
            string str1 = e.Segment.CorrespondingPoints[0].DataPoint.X.ToString();
            string str = e.Segment.CorrespondingPoints[0].DataPoint.Y.ToString();

            tooltip.Content = str1 + "," + str;
            ser.ToolTip = tooltip;*/
        }

        private void MouseLineLeave(object sender, Syncfusion.Windows.Chart.ChartMouseEventArgs e)
        {
//            Alternative code does same thing
            for (int i = 0; i < ChartDemo.Areas[0].Series.Count; ++i)
            {
                if (!ChartDemo.Areas[0].Series[i].Highlighted)
                {
                    ChartDemo.Areas[0].Series[i].StrokeThickness = 1;
                }
            }

            foreach (ChartSeries series1 in this.ChartDemo.Areas[0].Series)
            {
                if (series1.Annotations != null)
                    series1.Annotations.Items.Clear();
            }

            ChartSeries ser = sender as ChartSeries;
            ToolTip tooltip = ser.ToolTip as ToolTip;
            tooltip.Visibility = Visibility.Collapsed;

//            base.HandleMouseLeave(sender, e);
        }

        private void MouseLineClick(object sender, Syncfusion.Windows.Chart.ChartMouseEventArgs e)
        {
            for (int i = 0; i < ChartDemo.Areas[0].Series.Count; ++i)
            {
                if (ChartDemo.Areas[0].Series[i].Highlighted)
                {
/*                    Menu mainMenu = new Menu();
                    mainMenu.Background = Brushes.LightGreen;
                    mainMenu.Height = 300;
                    mainMenu.Width = 200;

                    MenuItem item1 = new MenuItem();
                    item1.Width = 150;
                    item1.Header = "Change Line Color to Orange";
                    mainMenu.Items.Add(item1);

                    MenuItem item2 = new MenuItem();
                    item2.Width = 150;
                    item2.Header = "Change Line Color to Green";
                    mainMenu.Items.Add(item2);

                    MenuItem item3 = new MenuItem();
                    item3.Width = 150;
                    item3.Header = "Change Line Color to Black";
                    item3.Click += new RoutedEventHandler(item3_Click);
                    mainMenu.Items.Add(item3);
                    mainMenu.Visibility = System.Windows.Visibility.Visible;*/

                    ChartDemo.Areas[0].Series[i].Interior = Brushes.PowderBlue;
                }
            }
//            base.MouseRightButtonDown(sender, e);
        }

        void item3_Click(object sender, RoutedEventArgs e)
        {

        }

        private void AddChart(object sender, RoutedEventArgs e)
        {
            //Creating datapoints collection.
            ChartListData data = new ChartListData();
            data.Add(new ChartPoint(100, 100));
            data.Add(new ChartPoint(200, 200));
            data.Add(new ChartPoint(333, 300));
            data.Add(new ChartPoint(422, 440));
            //Creating series.
            ChartSeries series = new ChartSeries();
            //Assigning points.
            series.Data = data;
            series.Label = "New Histo";
            ChartDemo.Areas[0].Series.Add(series);
        }
        private void AddLineChart(object sender, RoutedEventArgs e)
        {
            //Creating datapoints collection.
            ChartListData data = new ChartListData();
            data.Add(new ChartPoint(300, 300));
            data.Add(new ChartPoint(400, 600));
            data.Add(new ChartPoint(533, 700));
            data.Add(new ChartPoint(722, 840));
            //Creating series.
            ChartSeries series = new ChartSeries();
            //Assigning points.
            series.Data = data;
            series.Label = "New Line";
            series.Type = ChartTypes.Line;
            series.MouseClick += new ChartMouseEventHandler(MouseLineClick);
            series.MouseEnter += new ChartMouseEventHandler(MouseLineEnter);
            series.MouseLeave += new ChartMouseEventHandler(MouseLineLeave);
            series.ToolTip = series.Label;
            ChartDemo.Areas[0].Series.Add(series);
        }

        private void InvertXAxis(object sender, RoutedEventArgs e)
        {
            ChartDemo.Areas[0].PrimaryAxis.IsInversed = !ChartDemo.Areas[0].PrimaryAxis.IsInversed;
        }
        private void ChangeLineColorBlack(object sender, RoutedEventArgs e)
        {
            //DS1.Interior = Brushes.Black;
        }
        private void ChangeLineColorOlive(object sender, RoutedEventArgs e)
        {
            //DS1.Interior = Brushes.Olive;
        }
    }

    public class PressData : INotifyPropertyChanged
    {
        public PressData()//(double dP, double dD)
        {
//            Pressure = dP;
  //          Depth = dD;
        }

        private double _pressure;

        public double Pressure
        {
            get { return _pressure; }
            set 
            { 
                _pressure = value;
                this.OnPropertyChanged(new PropertyChangedEventArgs("Pressure"));
            }
        }
        private double _depth;

        public double Depth
        {
            get { return _depth; }
            set 
            { 
                _depth = value;
                this.OnPropertyChanged(new PropertyChangedEventArgs("Depth"));
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(PropertyChangedEventArgs args)
        {
            if (this.PropertyChanged != null)
                this.PropertyChanged(this, args);
        }
        #endregion
    }

    public class EMWData : INotifyPropertyChanged
    {
        public EMWData(double dEMW, double dEMW2, double dD)
        {
            EMW = dEMW;
            EMW2 = dEMW2;
            Depth2 = dD;
        }

        private double _EMW;

        public double EMW
        {
            get { return _EMW; }
            set 
            { 
                _EMW = value;
                this.OnPropertyChanged(new PropertyChangedEventArgs("EMW"));
            }
        }

        private double _EMW2;

        public double EMW2
        {
            get { return _EMW2; }
            set 
            {
                _EMW2 = value;
                this.OnPropertyChanged(new PropertyChangedEventArgs("EMW2"));
            }
        }

        private double _Depth2;

        public double Depth2
        {
            get { return _Depth2; }
            set 
            { 
                _Depth2 = value;
                this.OnPropertyChanged(new PropertyChangedEventArgs("Depth2"));
            }
        }
        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(PropertyChangedEventArgs args)
        {
            if (this.PropertyChanged != null)
                this.PropertyChanged(this, args);
        }
        #endregion
    }

    public class EMWs : ObservableCollection<EMWData>
    {
        public EMWs()
            : base()
        {
            Add(new EMWData(0, 0, 0));
            Add(new EMWData(10, 10, 100));
            Add(new EMWData(20, 15, 300));
            Add(new EMWData(30, 20, 400));
            Add(new EMWData(88, 25, 1000));
        }
    }

    public class Pressures : ObservableCollection<PressData>
    {
        public Pressures()
            : base()
        {
            Add(new PressData() {Pressure = 0, Depth = 0});
            Add(new PressData() {Pressure = 150, Depth = 110});
            Add(new PressData() {Pressure = 220, Depth = 330});
            Add(new PressData() {Pressure = 440, Depth = 550});
            Add(new PressData() {Pressure = 6660, Depth = 660});
        }
    }

    [ValueConversion(typeof(object), typeof(object))]
    public class Times2Converter : IValueConverter
    {
        #region IValueConverter Members

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {

            if (value == null)
            {
                if (targetType.Name.Contains("Nullable")) return false;
                else return "";
            }

                value = ((double)value*2.0);

            return value;

        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
